void setup()
{
  size(600, 600);             // def. fenstergroesse

  randomSeed(millis());       

  smooth();           // aktiviere antialiasing
  strokeWeight(1);    // linienbreite

  noLoop();
}

void draw()
{
  background(255);

  pushMatrix();
  translate(0, 0);                      // neue koordinaten
  wurzel(5);                            // ruft funktion wurzelringe auf, in der anzahl 5
  popMatrix();

  pushMatrix();
  translate(width, 0);
  rotate(PI/2);                         // Rotation des Baumes
  wurzel(6);
  popMatrix();

  pushMatrix();
  translate(0, height);
  rotate(PI/-2);
  wurzel(4);
  popMatrix();

  pushMatrix();
  translate(width, height);
  rotate(PI);
  wurzel(7);
  popMatrix();
}

void mousePressed()
{
  redraw();
}

// funktion wurzel 
void wurzel(int tiefe)    // Event mit Rückgabewert
{
  if (tiefe <= 0)         // teste ob das ende erreicht worden ist) ist "tiefe" kleiner wie null beginne mit blueten zu zeichnen
  {

    // zeichen blueten
    pushStyle();                            // ist eine Funktion die es ermöglicht, die Art (Stil) zu ändern und später zu dem, was Sie hatten Rückkehr, bezieht sich auf die aktuellen Style-Informationen (Original), push = öffnen, pop = schliessen 
    int clrbl = (int)random(100, 230);      // definiert den farbkanal als variable mit zufall
    stroke(0, 0, 0, 150);
    fill(0, clrbl, 80, clrbl);
    ellipse(0, 0, 130, 130);       // Hinterste Form einer Blüte
    ellipse(0, 0, 85, 85);         // 2 Hinterste Form einer Blüte
    ellipse(0, 0, 25, 115);        // hinterte Form querformig einer Blüte
    ellipse(0, 0, 115, 25);        // Vordere Form hochformig Blüte
    ellipse(0, 0, 50, 50);         // Vorderste Form einer Blüte


    popStyle();

    return;                        // Abbruch
  }


  // zeichne zweige
  int x;                            // platzhalter namens x
  int y;                            // platzhalter namens y
  int count = (int)random(1, 5);    // platzhalter count = (int) zufall 1 bis 5
  int clrwz = (int)random(230, 250);// platzhaler für zufallswert in den farbkanal
  for (int i = 0; i < count;i++)    // schleife läuft solange i gleich 0; i kleiner count; i++
  {
    x = (int)random(0, 150);       // breite in die die zweige wachsen; 0 bis 100
    y = (int)random(0, 150);       // richtung höhe die der zweig wachst; zwischen 0 bis 100

      stroke(0, 120, 80, 150);
      fill(clrwz,255,clrwz,150);
      triangle(30, y, x, 0, 0, 40);


    pushMatrix();
    translate(x, y);
    scale(random(.6, .85));
    wurzel(tiefe-1);              // wurzeltiefe -1 in der anzahl, Rückgabewert
    popMatrix();
  }
}

